%define name		tomcat5
%define full_name	jakarta-%{name}
%define version		5.0.25
%define majversion	5.0
%define release		1jpp.3AX
%define section		free

%define summary		Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
%define license		Apache Software License
%define distribution	JPackage
%define vendor		JPackage Project

%define jname		jasper5
%define tcuid		91

%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir		%{_sysconfdir}/%{name}
%define logdir		%{_localstatedir}/log/%{name}
%define homedir		%{_localstatedir}/%{name}
%define bindir		%{_localstatedir}/%{name}/bin
%define tempdir		%{_localstatedir}/cache/%{name}/temp
%define workdir		%{_localstatedir}/cache/%{name}/work
%define appdir		%{_localstatedir}/%{name}/webapps
%define serverdir	%{_localstatedir}/%{name}/server
%define commondir	%{_localstatedir}/%{name}/common
%define shareddir	%{_localstatedir}/%{name}/shared

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
Epoch:			0
License:		%{license}
Vendor:			%{vendor}
Distribution:		%{distribution}
Group: 			Networking/Daemons
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source:			http://jakarta.apache.org/builds/jakarta-tomcat-5.0/release/v%{version}/src/%{packdname}.tar.gz
Source3:		TOMCAT4.README.RPM
Source4: 		%{name}-%{majversion}.init
Source5:		%{name}-%{majversion}.conf.miracle
Source6:		%{name}-%{majversion}.wrapper
Source7:		jasper5-%{majversion}.wrapper
Source8:		%{name}-%{majversion}.logrotate
Patch0:			tomcat5-5.0.25-catalinash.patch
BuildRoot:		%{_tmppath}/%{name}-root-%{version}

BuildRequires:		ant, ant-optional


%description
Server that conforms to the Servlet 2.4 and JSP 2.0
specifications from Java Software.

Develop Web applications in Java.

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0

cd %{packdname}
%patch0 -p1 -b .catalinash

%build

pushd %{packdname}
cp $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/LICENSE .
popd 
cd $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src

## added for AX ##
cat >> build.properties <<EOBP
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-connectors/
jasper.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-jasper/jasper2
ant.jar=/usr/share/java/ant.jar
servletapi.jar=/usr/share/java/servletapi5.jar
EOBP

ant -Dbuild.compiler=modern -Djava.home=%{java_home} build

%install
rm -rf $RPM_BUILD_ROOT

# install RPM README
cp %{SOURCE3} .

# build initial path structure
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}

install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_sysconfdir}/{init.d,logrotate.d}}

# sysv init and logging
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install %{SOURCE5} $RPM_BUILD_ROOT/%{confdir}/%{name}.conf

pushd $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/build
    mv bin/*     ${RPM_BUILD_ROOT}%{bindir}
    mv common/*  ${RPM_BUILD_ROOT}%{commondir}
    mv conf/*    ${RPM_BUILD_ROOT}%{confdir}
    mv server/*  ${RPM_BUILD_ROOT}%{serverdir}
    mv shared/*  ${RPM_BUILD_ROOT}%{shareddir}
    mv webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd


# rename catalina/jasper into dtomcat5/djasper4 to let wrapper take precedence
install $RPM_BUILD_ROOT%{bindir}/catalina.sh $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{bindir}/catalina.sh.*

# install wrapper as tomcat5/jasper4
install %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{name}
install %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/%{jname}

# install logrotate support
install %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat



# Perform FHS translation
# (final links)
#pushd $RPM_BUILD_ROOT%{homedir}
#    ln -fs %{confdir}   conf
#    ln -fs %{logdir}    logs
#    ln -fs %{workdir}   work
#    ln -fs %{tempdir}   temp
#popd

cd $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src
find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | sed s+$RPM_BUILD_ROOT++g > homelinks

%clean
 rm -rf $RPM_BUILD_ROOT


%post
# install tomcat5 (but don't activate)
/sbin/chkconfig --add %{name}
ln -s /etc/tomcat5 /var/tomcat5/conf
ln -s /var/log/tomcat5 /var/tomcat5/logs
ln -s /var/cache/tomcat5/work /var/tomcat5/work
ln -s /var/cache/tomcat5/temp /var/tomcat5/temp


%preun
# Always clean up wordir and tempdir on upgrade/removal
rm -rf %{workdir}/* %{tempdir}/*
rm -rf /var/tomcat5/conf
rm -rf /var/tomcat5/temp
rm -rf /var/tomcat5/work
rm -rf /var/tomcat5/logs

if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}

    %{_sbindir}/userdel tomcat5 >> /dev/null 2>&1 || :
    %{_sbindir}/groupdel tomcat5 >> /dev/null 2>&1 || :
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}
fi

%pre
# Add the "tomcat5" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{tcuid} -r tomcat5 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat5" -u %{tcuid} -g tomcat5 \
    -s /bin/sh -r -d %{homedir} tomcat5 2> /dev/null || :


%files 
%defattr(644,root,root,755)
%doc TOMCAT4.README.RPM %{packdname}/jakarta-tomcat-5/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt}
# Normal directories
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/%{name}
%dir %{_localstatedir}/cache/%{name}
%dir %{commondir}
%dir %{serverdir}
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib

# Directories with special permissions
%attr(770,root,tomcat5)		%dir                  %{appdir}
%attr(775,root,tomcat5)    	%dir                  %{confdir}
%attr(775,root,tomcat5)    	%dir                  %{tempdir}
%attr(775,root,tomcat5)    	%dir                  %{workdir}
%attr(755,tomcat5,tomcat5)	%dir                  %{logdir}
%attr(775,root,tomcat5)     %dir                  %{confdir}/Catalina
%attr(775,root,tomcat5)     %dir                  %{confdir}/Catalina/localhost

%attr(755,root,root) 	  	%{_bindir}/*
%attr(755,root,root) 	  	%{bindir}/*
%attr(755,root,root)  	  	%{_sysconfdir}/init.d/%{name}

%attr(644,root,tomcat5)    	%config(noreplace)      %{confdir}/catalina.policy
%attr(644,root,tomcat5)    	%config(noreplace)      %{confdir}/catalina.properties
%attr(660,root,tomcat5)    	%config(noreplace)      %{confdir}/jk2.properties
%attr(660,root,tomcat5)    	%config(noreplace)      %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat5.conf
%config(noreplace) %{confdir}/server-minimal.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml

# %{confdir}/server-noexamples.xml.config
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{commondir}/*
%{serverdir}/lib/*
# %{tempdir}/README.txt
# file for webapps
%defattr(644,root,tomcat5,775)
%dir %{appdir}/servlets-examples
%{appdir}/servlets-examples/*
%dir %{appdir}/jsp-examples
%{appdir}/jsp-examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*
# file for admin-webapps
%defattr(640,root,tomcat5,750)
%attr(660,root,tomcat5) %{confdir}/Catalina/localhost/manager.xml
%{confdir}/Catalina/localhost/balancer.xml
%{confdir}/Catalina/localhost/admin.xml
%dir %{appdir}/balancer
%{appdir}/balancer/*
%dir %{serverdir}/webapps
%{serverdir}/webapps/*

%changelog
* Fri Jun 11 2004 Daisuke Tonoki <tonoki@miraclelinux.com> 5.0.25-1jpp.3AX
- add ant.jar and servletapi5.jar build.properties.

* Fri Jun 11 2004 Daisuke Tonoki <tonoki@miraclelinux.com> 5.0.25-1jpp.2AX
- remove jdksetup from Require.

* Fri Jun 10 2004 Daisuke Tonoki <tonoki@miraclelinux.com> 5.0.25-1jpp.1AX
- remove all noopensource jars.
- update to 5.0.25.

* Wed Jun 09 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-3jpp
- Change default webapps file permissions from 0640 -> 0644

* Tue Jun 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.24-2jpp
- Allow browsing of webapps directory so that JOnAS can build.

* Mon May 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-1jpp
- Update to 5.0.24
- Require xerces-j2 2.6.2 (release notes 5.0.21), also require ant < 1.6
  as tomcat5 doesn't seem to build cleanly with 1.6 yet.

* Fri Mar 19 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-2jpp
- Set JAVA_ENDORSED_DIRS by default in tomcat5.conf, it is otherwise empty
  Suggestion from Aleksander Adamowski <aleksander.adamowski@altkom.pl>  

* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-1jpp
- Update to 5.0.19

* Fri Jan 23 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.18-1jpp
- Update to 5.0.18
- Build catalina before connectors
- Hack connectors build
- Require xerces-j2 2.6.0 (release notes 5.0.17)

* Sat Jan 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-4jpp
- Create TC4 user and group separately, lets TC5 work out of the box
  on Trustix (Patch from Iain Arnell)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-3jpp
- servletapi5 is required
- move confdir/Catalina from admin-webapps to main package
  (otherwise we end up requiring tomcat5-admin-webapps for struts-webapps)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-2jpp
- Fix conflict with tomcat4 catalina-ant.jar in %%_javadir by renaming it
  catalina-ant5.jar for now.

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-1jpp
- First build for JPackage

* Mon Dec 29 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.11
- Merge changes from tomcat4.init to tomcat5.init

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.10
- Some jsp-examples require jakarta-taglibs-standard to work

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.9.1
- Struts should be 1.1 or later according to the release notes
- The /admin webapp works now as well
- manager.xml needs to be group writeable, otherwise tomcat complains

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.7
- Accept an older version of xerces-j2 as well.

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.6
- Require xerces-j2 instead of just jaxp_parser_impl
- Require jpackage commons-logging instead of internal version

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.5
- Tomcat5 isn't beta anymore

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.4
- Place jspapi, jmxri, commons-el in common/lib as mentioned in the
  upstream RELEASE-NOTES.txt. This makes jsps actually work.

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.3
- Separated jakarta-commons-el from tomcat
- Require servletapi5 and jakata-commons-el
- Added Patch #4 (tomcat5-5.0.16-cluster-pathelement.patch) which fixes
  build failure when servlet-api is renamed something else than the default
- Added Patch #5 (tomcat5-5.0.16-skip-build-on-install.patch) which corrects
  servletapi/jspapi related build snafu on install. They're already built so
  it's OK to skip.

* Thu Dec  4 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.1
- 5.0.16
- jakarta-commons-el included here instead of somewhere else for now,
  packaging unfinished
- Patch #3 removes dependency to jsvc.tar.gz which doesn't seem to be anywhere

* Tue Aug  5 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.12-0.beta.1
- Based on JPackage.org's tomcat4 .spec
- No compat stuff anymore.
- First build

